using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Collections;

namespace CapturePackets
{


    /// <summary>
    ///   (instance) 
    /// </summary>
    public  class AllCountersInstance
    {
      //    igmp   (     , 
      //         1 ,        
      //   )
      public int igmp_total = 0; 
      public int icmp_total = 0; //  icmp 
      public int tcp_total = 0; // tcp 
      public int udp_total = 0; //  udp 
      public int unknown_total = 0; //   
      public PerformanceCounter _counter; // 

      public void UpdateInstances()
      {
          if(_counter != null)
          {
            _counter.InstanceName = "IGMP";
            _counter.RawValue = igmp_total;

            _counter.InstanceName = "ICMP";
            _counter.RawValue = icmp_total;

            _counter.InstanceName = "TCP";
            _counter.RawValue = tcp_total;

            _counter.InstanceName = "UDP";
            _counter.RawValue = udp_total;

          }
      }
      
        /// <summary>
        ///    
        /// </summary>
        public void ResetInstaces()
        {

          igmp_total = 0; 
          icmp_total = 0; 
          tcp_total = 0; 
          udp_total = 0;
          unknown_total = 0;
         
        } 
    };
   
    /// <summary>
    ///   
    /// </summary>
    [Serializable]
    [ClassInterface(ClassInterfaceType.AutoDual)]
    public class PerformanceObject
    {
        private static PerformanceObject _PerformanceObject= null;
        //private PerformanceCounterCategory _category = null;
        private string _CategoryName;
        private Hashtable _htable = new Hashtable();
        private static string _CategoryHelp;
        /// <summary>
        ///     ,     
        /// </summary>
        /// <param name="_name"> </param>
        public static PerformanceObject GetPerformanceObject(string _name)
        {
          if(_PerformanceObject == null)
            _PerformanceObject= new PerformanceObject();
          _PerformanceObject._CategoryName = _name;
          _CategoryHelp = "       ";
          return _PerformanceObject;
         

        }
        
        public void RemoveIP(string _ip)
        {
            if(_htable.Contains(_ip))
            {
               AllCountersInstance _instance = (AllCountersInstance)_htable[_ip];
              _htable.Remove(_ip);
              _instance._counter.Dispose();
            }
        
        }

        public void BeginInit()
        {
        
        }

        public void EndInit()
        {
            
         try
          {

            if(!PerformanceCounterCategory.Exists(_CategoryName))
            {
              CounterCreationDataCollection   ccds = new CounterCreationDataCollection();

              foreach(string _ip in _htable.Keys)   
              {
                  CounterCreationData ccd = new CounterCreationData();
                  ccd.CounterType = PerformanceCounterType.NumberOfItems32;
                  ccd.CounterName = _ip;
                  ccds.Add(ccd);
              }
                PerformanceCounterCategory.Create(_CategoryName, _CategoryHelp,ccds);
                foreach(string _ip in _htable.Keys)   
                {
                    AllCountersInstance _allinstances =  (AllCountersInstance)_htable[_ip];
                  _allinstances._counter = new PerformanceCounter(_CategoryName, _ip, "IGMP", false);
                 _allinstances.UpdateInstances();
                }
            } 
            
          }
          catch
          {
               System.Diagnostics.Debug.WriteLine("Unable to create counter");
          }
   
        
        }
        
        public bool AddIP(string _ip)
        {
            if(!_htable.Contains(_ip))
            {
                _htable.Add(_ip, new AllCountersInstance());
            }            
           else
                return false;

            return true;

        }
        
        /// <summary>
        ///  instances  
        /// </summary>
        /// <param name="_ip">ip     AllCountersInstance</param>
        /// <returns> AllCountersInstance</returns>
        public AllCountersInstance GetInstances(string _ip)
        {
          if(_htable.Contains(_ip))
            return (AllCountersInstance)_htable[_ip];
          else
              return null;
        }

        public  Hashtable GetCounters()
        {
         return _htable;
        }
        
        /// <summary>
        ///    
        /// </summary>
        public void UpdateAllCounters()
        {
          foreach(AllCountersInstance instance in _htable.Values)
          {
            instance.UpdateInstances();
            instance.ResetInstaces();
          }         
        }


        ~PerformanceObject()
        {
         if(PerformanceCounterCategory.Exists(_CategoryName))
              PerformanceCounterCategory.Delete(_CategoryName);
        }
    }
}
