using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using RawSockets;
using System.Threading;

namespace CapturePackets
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class CaptureForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.ListBox IPList;
        private System.Windows.Forms.ListBox OutInfo;
        private System.Windows.Forms.Button CaptureButton;
        private System.Windows.Forms.Button StopButton;
        private System.Windows.Forms.Timer UpdateCounters;
        private System.Windows.Forms.CheckBox cbShowPacket;
        private System.ComponentModel.IContainer components;

		public CaptureForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.IPList = new System.Windows.Forms.ListBox();
            this.CaptureButton = new System.Windows.Forms.Button();
            this.StopButton = new System.Windows.Forms.Button();
            this.OutInfo = new System.Windows.Forms.ListBox();
            this.UpdateCounters = new System.Windows.Forms.Timer(this.components);
            this.cbShowPacket = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            // 
            // IPList
            // 
            this.IPList.Location = new System.Drawing.Point(24, 16);
            this.IPList.Name = "IPList";
            this.IPList.Size = new System.Drawing.Size(152, 225);
            this.IPList.TabIndex = 0;
            this.IPList.SelectedIndexChanged += new System.EventHandler(this.ChangeSelectedIP);
            // 
            // CaptureButton
            // 
            this.CaptureButton.Location = new System.Drawing.Point(184, 80);
            this.CaptureButton.Name = "CaptureButton";
            this.CaptureButton.Size = new System.Drawing.Size(96, 32);
            this.CaptureButton.TabIndex = 1;
            this.CaptureButton.Text = "Capture";
            this.CaptureButton.Click += new System.EventHandler(this.CaptureButton_Click);
            // 
            // StopButton
            // 
            this.StopButton.Location = new System.Drawing.Point(184, 128);
            this.StopButton.Name = "StopButton";
            this.StopButton.Size = new System.Drawing.Size(96, 32);
            this.StopButton.TabIndex = 2;
            this.StopButton.Text = "Stop";
            this.StopButton.Click += new System.EventHandler(this.StopButton_Click);
            // 
            // OutInfo
            // 
            this.OutInfo.HorizontalScrollbar = true;
            this.OutInfo.Location = new System.Drawing.Point(296, 16);
            this.OutInfo.Name = "OutInfo";
            this.OutInfo.ScrollAlwaysVisible = true;
            this.OutInfo.Size = new System.Drawing.Size(400, 238);
            this.OutInfo.TabIndex = 3;
            // 
            // UpdateCounters
            // 
            this.UpdateCounters.Enabled = true;
            this.UpdateCounters.Interval = 500;
            this.UpdateCounters.Tick += new System.EventHandler(this.OnTimer);
            // 
            // cbShowPacket
            // 
            this.cbShowPacket.Location = new System.Drawing.Point(296, 264);
            this.cbShowPacket.Name = "cbShowPacket";
            this.cbShowPacket.Size = new System.Drawing.Size(240, 24);
            this.cbShowPacket.TabIndex = 4;
            this.cbShowPacket.Text = "Show Packets";
            // 
            // CaptureForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(704, 389);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.cbShowPacket,
                                                                          this.OutInfo,
                                                                          this.StopButton,
                                                                          this.CaptureButton,
                                                                          this.IPList});
            this.Name = "CaptureForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.InitForm);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new CaptureForm());
		}

        private void InitForm(object sender, System.EventArgs e)
        {
            // ip   
            IPHostEntry HostEntry = Dns.Resolve(Dns.GetHostName());
            _PerformanceObject.BeginInit();
            if(HostEntry.AddressList.Length > 0)
            {
                foreach(IPAddress ip in HostEntry.AddressList)
                {
                    // ip  
                    IPList.Items.Add(ip.ToString());
                    _PerformanceObject.AddIP(ip.ToString());
                }
            }
           _PerformanceObject.EndInit();
           _pSniffer = Sniffer.GetSnifferInstance();
           _pSniffer.Receive += new CapturePacket(ReceivePacket);
        }

        private void ChangeSelectedIP(object sender, System.EventArgs e)
        {
            if(IPList.SelectedIndex == -1)
                return;
            string _ip = IPList.SelectedItem.ToString();
           ChangeButtonVisibility(_ip);
            
        }

        private void ChangeButtonVisibility(string _ip)
        {
            if(_pSniffer.IPinList(_ip))
            {
                CaptureButton.Enabled = false;
                StopButton.Enabled = true;
            }
            else
            {
                CaptureButton.Enabled = true;
                StopButton.Enabled = false;           
            }
        
        }

        protected Sniffer _pSniffer = null;

        private void CaptureButton_Click(object sender, System.EventArgs e)
        {
            if(IPList.SelectedIndex == -1)
                return;
            string _ip = IPList.SelectedItem.ToString();
             _pSniffer.AddIP(_ip);
            ChangeButtonVisibility(_ip);
        }

        private void StopButton_Click(object sender, System.EventArgs e)
        {
            if(IPList.SelectedIndex == -1)
                return;
            string _ip = IPList.SelectedItem.ToString();
            _pSniffer.RemoveIp(_ip);
            ChangeButtonVisibility(_ip);       
        }

        private  void ReceivePacket(string _ip, IpHeader _header, object _other_header)
        {
            string out_string  = string.Format("interface {0}: ", _ip) + "; protocol:";
            string src_addr =  (new IPAddress(_header.ip_srcaddr)).ToString(), dest_addr = (new  IPAddress(_header.ip_destaddr)).ToString();
            int total_length = IPAddress.NetworkToHostOrder(_header.ip_totallength);
            AllCountersInstance _instances = _PerformanceObject.GetInstances(_ip);
            switch(_header.ip_protocol)
            {
                case 1: out_string += "ICMP"; Interlocked.Exchange(ref _instances.icmp_total, _instances.icmp_total + total_length);break;
                case 2: out_string += "IGMP"; Interlocked.Exchange(ref _instances.igmp_total, _instances.igmp_total + total_length);break;
                case 6: 
                    out_string += "TCP";Interlocked.Exchange(ref _instances.tcp_total, _instances.tcp_total + total_length);
                    src_addr += ":" + IPAddress.NetworkToHostOrder( ((TCPHeader)_other_header).SourcePort).ToString();
                    dest_addr += ":" + IPAddress.NetworkToHostOrder(((TCPHeader)_other_header).DestinationPort).ToString();;
                    break;
                case 17: 
                    Interlocked.Exchange(ref _instances.udp_total, _instances.udp_total + total_length);
                    src_addr += ":" + IPAddress.NetworkToHostOrder(((UDPHeader)_other_header).SourcePort).ToString();
                    dest_addr += ":" + IPAddress.NetworkToHostOrder(((UDPHeader)_other_header).DestinationPort).ToString();
                    out_string += "UDP";break;
                default: out_string += "UNKNOWN";break;           
            }
            out_string += string.Format("; {0} -> {1}", src_addr, dest_addr);
            if(cbShowPacket.Checked)
             OutInfo.Items.Add(out_string);
            //_PerformanceObject.UpdateAllCounters();
        }

        public PerformanceObject  _PerformanceObject = PerformanceObject.GetPerformanceObject("Traffic");

        private void OnTimer(object sender, System.EventArgs e)
        {
         _PerformanceObject.UpdateAllCounters();
        }

	}
}
