using System;
using System.Runtime.InteropServices;
using System.Net.Sockets;
using System.Net;
using System.Collections;
using System.Diagnostics;

//  ip 
namespace RawSockets
{
    [Serializable]
    [ClassInterface(ClassInterfaceType.AutoDual)]

    public class BaseSocket
    {
        /// <summary>
        ///     
        /// </summary>
        protected int len_receive_buf;
        /// <summary>
        ///       
        /// </summary>
        protected int len_send_buf;
        /// <summary>
        ///      
        /// </summary>
        public byte []receive_buf = null;
        /// <summary>
        ///     ,  
        /// </summary>
        public byte []send_buf = null;
        /// <summary>
        ///   
        /// </summary>
        protected Socket socket = null; 
        /// <summary>
        /// SIO_RCVALL    ,     (  SDK)
        /// </summary>
        const int SIO_RCVALL = unchecked((int)0x98000001);
        /// <summary>
        /// 
        /// </summary>
        public BaseSocket()
        {
            len_receive_buf = 4096;
            len_send_buf = 4096;
            receive_buf = new byte[len_receive_buf];
            send_buf = new byte[len_send_buf];
        }
       
        /// <summary>
        ///      ip
        /// </summary>
        /// <param name="ip">ip       </param>
        public bool CreateAndBindSocket(string ip)
        {
            try
            {
                socket = new Socket(AddressFamily.InterNetwork, SocketType.Raw, ProtocolType.IP);
                socket.Blocking = false;
                socket.Bind(new IPEndPoint(IPAddress.Parse(ip), 0));
            }
            catch
            {
             Shutdown();
             return false;
            }
           return true;
        }
        /// <summary>
        ///  ,    <see cref="CreateAndBindSocket"/>
        /// </summary>
        public void Shutdown()
        {
            #if DEBUG
               Debug.WriteLine("Socket Shutdown");
            #endif
            if(socket != null)
            {
                try
                {
                    socket.Shutdown(SocketShutdown.Receive);
                    socket.Close();
                }
                catch{}
                socket = null;
            }
        
        }
      
        /// <summary>
        ///     
        /// </summary>
        public int LengthReceiveBuf
        {
            get
            {
                return len_receive_buf;
            }
            set
            {
                lock(receive_buf)
                {
                    len_receive_buf = value;
                    receive_buf = new byte[len_receive_buf];
                }
            }
        } 
  
        /// <summary>
        ///   ,   
        /// </summary>
        public int LengthSendBuf
        {
            get
            {
                return len_send_buf;
            }
            set
            {
                lock(send_buf)
                {
                    len_send_buf = value;
                    send_buf = new byte[len_send_buf];
                }
            }
        }
        public bool SetSockoption()
        {
            bool ret_value = true;
            try
            {
                socket.SetSocketOption(SocketOptionLevel.IP, SocketOptionName.HeaderIncluded, 1);
                //     true
                // Platform SDK   2       
                byte []IN = new byte[4]{1, 0, 0, 0};
                byte []OUT = new byte[4];
                int ret_code = socket.IOControl(SIO_RCVALL, IN, OUT);
                ret_code = OUT[0] + OUT[1] + OUT[2] + OUT[3];
                if(ret_code != 0)
                    ret_value = false;
            }
            catch(SocketException)
            {
                ret_value = false;
            }
            return ret_value;
        }

        /// <summary>
        ///  
        /// </summary>
        public Socket Handle
        {
            get
            {
                return socket;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        ~BaseSocket()
        {
            if(socket != null)
              socket.Close();
        }
          
        public override int GetHashCode()
        {
         if(socket != null)
             return socket.GetHashCode();
         else
          return 0;

        }
         

    }

    /// <summary>
    ///     IP ,    rfc 791
    /// </summary>
 
 

    public class Sniffer
	{
		protected Sniffer()
		{
		 _SocketList = new Hashtable();
         _dReceive = new AsyncCallback(EndReceivePacket);
        _EndInvokeReceive = new AsyncCallback(EndCallbackReceive);        

        }
        
        protected static Sniffer pSniffer = null;

        /// <summary>
        ///  ,       
        /// </summary>
        /// <returns>  Sniffer</returns>
        static public Sniffer GetSnifferInstance()
        {
         if(pSniffer != null)
             return pSniffer;
         else
            return pSniffer = new Sniffer();
        }

        /// <summary>
        ///         ,
        ///     ip
        /// </summary>
        /// <param name="_ip">ip     </param>
        public void AddIP(string _ip)
        {
         //     
           if(_SocketList.Contains(_ip))
             return;
         // ,  
          BaseSocket _socket = new BaseSocket();
         if(!_socket.CreateAndBindSocket(_ip))
             return;
          if(!_socket.SetSockoption())
              return;
         _SocketList.Add(_ip, _socket);
         ListenSocket(_socket);
        }
       
        /// <summary>
        ///         
        /// </summary>
        /// <param name="_ip">ip      </param>
        public void RemoveIp(string _ip)
        {
            if(!_SocketList.Contains(_ip))
                return;
            BaseSocket _socket = (BaseSocket)_SocketList[_ip];           
            _socket.Shutdown();
            _SocketList.Remove(_ip);
        }

        /// <summary>
        ///      
        /// </summary>
        /// <param name="_socket">socket   </param>
        protected void ListenSocket(BaseSocket _socket)
        {
          if(_socket.Handle != null)
            {
              try
              {
                  _socket.Handle.BeginReceive(_socket.receive_buf, 0, _socket.LengthReceiveBuf, SocketFlags.None, _dReceive, _socket);
              }
              catch{return;}
          }
        }
       

        /// <summary>
        ///  
        /// </summary>
        protected Hashtable _SocketList = null;

        /// <summary>
        ///  
        /// </summary>
        public event CapturePacket Receive = null;
        
        
        /// <summary>
        ///    
        /// </summary>
        /// <param name="ar"></param>
        protected void EndReceivePacket(IAsyncResult ar)
        {
          BaseSocket _socket = (BaseSocket)ar.AsyncState;
          int _bytesReceive;
            try
            {
                _bytesReceive  = _socket.Handle.EndReceive(ar);
            }
            catch{return;}
         
          if(Receive != null)
            {
              IpHeader _header = new IpHeader();
              unsafe
              {
                  //  
                  Marshal.Copy(_socket.receive_buf, 0,  new IntPtr(&_header), sizeof(IpHeader));
              }
              object _other_header = null;
              switch(_header.ip_protocol)
              {                 
                  // TCP header((_header.ip_verlen & 0x0F) << 2 -  TCP )
                  case 6:
                      TCPHeader _tcp_header = new TCPHeader();
                      unsafe
                      {
                       Marshal.Copy(_socket.receive_buf, (_header.ip_verlen & 0x0F) << 2,  new IntPtr(&_tcp_header), sizeof(TCPHeader));
                      };
                      _other_header = _tcp_header;break;
                   // UDP header
                  case 17:
                      UDPHeader _udp_header = new UDPHeader();
                      unsafe
                      {
                          Marshal.Copy(_socket.receive_buf, (_header.ip_verlen & 0x0F) << 2,  new IntPtr(&_udp_header), sizeof(UDPHeader));
                      };
                      _other_header = _udp_header;break;
              }
              //   
              Receive.BeginInvoke(((IPEndPoint)_socket.Handle.LocalEndPoint).Address.ToString(), _header, _other_header, _EndInvokeReceive, _socket);             
          }
        }

        
        /// <summary>
        ///         
        /// </summary>
        /// <param name="ar"></param>
        protected void EndCallbackReceive(IAsyncResult ar)
        {
         Receive.EndInvoke(ar);
         BaseSocket _socket = (BaseSocket)ar.AsyncState;
         if(_socket.Handle != null)
            try
            {
                _socket.Handle.BeginReceive(_socket.receive_buf, 0, _socket.LengthReceiveBuf, SocketFlags.None, _dReceive, _socket);
            }
            catch
            {
                return;
            }
         }
        

        /// <summary>
        ///        
        /// </summary>
        protected AsyncCallback _dReceive = null;
        /// <summary>
        ///       ,  
        ///   
        /// </summary>
        protected AsyncCallback _EndInvokeReceive = null;

        /// <summary>
        ///     ip   
        /// </summary>
        /// <param name="_ip">ip   </param>
        /// <returns>ture    false</returns>
        public bool IPinList(string _ip)
        {
            return _SocketList.Contains(_ip);
        }
    }
}
